-- name: [CS] dragapult
-- description: Our favorite ghost type!\n\n\\#11965f\\This Pack requires Character Select\nto use as a Library!

--[[
    API Documentation for Character Select can be found below:
    https://github.com/Squishy6094/character-select-coop/blob/main/API-doc.md

    Use this if you're curious on how anything here works >v<
]]

local E_MODEL_dragapult = smlua_model_util_get_id("dragapult_geo")

local TEX_dragapult_ICON = get_texture_info("dragapult-icon")

local TEXT_MOD_NAME = "dragapult"

local VOICETABLE_dragapult = {
   --[CHAR_SOUND_OKEY_DOKEY] = 'StartLevel.ogg', -- Starting game
    [CHAR_SOUND_LETS_A_GO] = nil, -- Starting level
    [CHAR_SOUND_OOOF] = 'Dano-2draga.ogg',
    [CHAR_SOUND_OOOF2] = 'Dano-2draga.ogg',
    [CHAR_SOUND_WAH2] ='Agarre-borde-draga.ogg',
    [CHAR_SOUND_PUNCH_YAH] = 'golpe-1-draga.ogg', -- Punch 1
    [CHAR_SOUND_PUNCH_WAH] = 'golpe2-draga.ogg', -- Punch 2
    [CHAR_SOUND_PUNCH_HOO] = 'golpe-3-draga.ogg', -- Punch 3
    [CHAR_SOUND_YAH_WAH_HOO] = {'Salto-1-draga.ogg', 'Salto-2-draga.ogg'}, -- First/Second jump sounds
    [CHAR_SOUND_HOOHOO] = 'Salto-2-draga.ogg', -- Third jump sound
    [CHAR_SOUND_YAHOO_WAHA_YIPPEE] = 'Salto-3-draga.ogg', -- Triple jump sounds
    [CHAR_SOUND_UH] = 'Walljum-draga.ogg', -- Wall bonk
    [CHAR_SOUND_UH2] = nil, -- Landing after long jump
    [CHAR_SOUND_UH2_2] = 'Agarre-borde-draga.ogg', -- Same sound as UH2; jumping onto ledge
    [CHAR_SOUND_HAHA] = nil, -- Landing triple jump
    [CHAR_SOUND_YAHOO] = 'Salto-3-draga.ogg', -- Long jump
    [CHAR_SOUND_HAHA_2] = nil,
    [CHAR_SOUND_DOH] = 'Walljum-draga.ogg', -- Long jump wall bonk
    [CHAR_SOUND_WHOA] = 'Agarre-borde-draga.ogg', -- Grabbing ledge
    [CHAR_SOUND_EEUH] = nil, -- Climbing over ledge
    [CHAR_SOUND_WAAAOOOW] = 'Caida-larga-draga.ogg', -- Falling a long distance
    [CHAR_SOUND_TWIRL_BOUNCE] = nil, -- Bouncing off of a flower spring
    [CHAR_SOUND_GROUND_POUND_WAH] = nil, 
    [CHAR_SOUND_HRMM] = 'golpe-1-draga.ogg', -- Lifting something
    [CHAR_SOUND_HERE_WE_GO] = 'Victoria-draga.ogg', -- Star get
    [CHAR_SOUND_SO_LONGA_BOWSER] = 'golpe-3-draga.ogg', -- Throwing Bowser
--DAMAGE
    [CHAR_SOUND_ATTACKED] = 'Dano-2draga.ogg', -- Damaged
    [CHAR_SOUND_PANTING] = 'Vida-bajadraga.ogg', -- Low health
    [CHAR_SOUND_ON_FIRE] = 'Dano-2draga.ogg', -- Burned
--SLEEP SOUNDS
    [CHAR_SOUND_IMA_TIRED] = nil, -- Mario feeling tired
    [CHAR_SOUND_YAWNING] = nil, -- Mario yawning before he sits down to sleep
    [CHAR_SOUND_SNORING1] = nil, -- Snore Inhale
    [CHAR_SOUND_SNORING2] = nil, -- Exhale
    [CHAR_SOUND_SNORING3] = nil, -- Sleep talking / mumbling
--COUGHING (USED IN THE GAS MAZE)
    [CHAR_SOUND_COUGHING1] = nil, -- Cough take 1
    [CHAR_SOUND_COUGHING2] = nil, -- Cough take 2
    [CHAR_SOUND_COUGHING3] = nil, -- Cough take 3
--DEATH
    [CHAR_SOUND_DYING] = 'Dano-1draga.ogg', -- Dying from damage
    [CHAR_SOUND_DROWNING] = nil, -- Running out of air underwater
    [CHAR_SOUND_MAMA_MIA] = nil -- Booted out of level
}

local PALETTE_dragapult = {
    [PANTS]  = "5CC8C7",
    [SHIRT]  = "FBEDA5",
    [GLOVES] = "FA6D80",
    [SHOES]  = "577D73",
    [HAIR]   = "99D5B5",
    [SKIN]   = "425765",
    [CAP]    = "0A1827",
}

--[[ dragapult does NOT take his hat off under ANY circumstances, as canonically, hatless dragapult is a horrid sight.
local CAPTABLE_dragapult = {
    normal = smlua_model_util_get_id("dragapult_cap_normal_geo"),
    wing = smlua_model_util_get_id("dragapult_cap_wing_geo"),
    metal = smlua_model_util_get_id("dragapult_cap_metal_geo"),
    metalWing = smlua_model_util_get_id("dragapult_cap_wing_geo"),
}
--]]
if _G.charSelectExists then
    CT_CHAR = _G.charSelect.character_add("dragapult", "Carries a pair of Dreepy", "Made by @Asplatim , @Shagapult and @DegXD24 on twitter", {r = 66, g = 87, b = 101}, E_MODEL_dragapult, CT_MARIO, TEX_dragapult_ICON)
--      _G.charSelect.character_add_caps(E_MODEL_dragapult, CAPTABLE_dragapult)

    _G.charSelect.character_add_palette_preset(E_MODEL_dragapult, PALETTE_dragapult)

     --the following must be hooked for each character added

    _G.charSelect.character_add_voice(E_MODEL_dragapult, VOICETABLE_dragapult)
    hook_event(HOOK_CHARACTER_SOUND, function (m, sound)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_dragapult then return _G.charSelect.voice.sound(m, sound) end
    end)
    hook_event(HOOK_MARIO_UPDATE, function (m)
        if _G.charSelect.character_get_voice(m) == VOICETABLE_dragapult then return _G.charSelect.voice.snore(m) end
    end)
else
    djui_popup_create("\\#ffffdc\\\n"..TEXT_MOD_NAME.."\nRequires the Character Select Mod\nto use as a Library!\n\nPlease turn on the Character Select Mod\nand Restart the Room!", 6)
end